﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=9.07
@EndOfDesignText@
'Static code module
Sub Class_Globals	
	Public vuetify As VuetifyApp
	Public page As VueComponent
	Public path As String
	Public name As String = "home"
	
	Private banano As BANano				'ignore
	
	Private Mqtt As BANanoMQTTClient
	Private clientId As String
	Private Connected as Boolean
		
	Private VContainer1 As VContainer		'ignore
	Private btnSend As VBtn					'ignore
	Private VList1 As VList					'ignore
	Private VListOptions1 As VListOptions	'ignore
	Private VTextFieldMessage As VTextField	'ignore
End Sub

Sub Initialize(v As VuetifyApp)						'ignoreDeadCode
	'establish a reference to the app
	vuetify = v
	'initialize the component
	page.Initialize(Me, name)
	page.vuetify = vuetify
	'make this the start page
	page.StartPage
	path = page.path

	'build the page html here
	banano.LoadLayout(page.Here, "home")
	VList1.SetOptions(VListOptions1)
	VTextFieldMessage.BindState(page)
	
	'add this route component to the app
	vuetify.AddRoute(page)
End Sub	

Sub created		'IgnoreDeadCode
	Log("created")
	Connected=False
	clientId = "BananoUser" & Rnd(1,9999)
	Mqtt.Initialize("mqtt", "test.mosquitto.org",8080 , "/mqtt", False, clientId) ' note: the path MUST be /mqtt for this test server
End Sub

Sub mounted		'ignoreDeadCode
	Dim ops As BANanoMQTTConnectOptions
	ops.Initialize("", "")
	ops.CleanSession = False
	Mqtt.Connect2(ops)
	
	VList1.Clear(page)
End Sub

Private Sub btnSend_Click (e As BANanoEvent)			'ignoreDeadCode
	Dim Message As String = clientId & "|" &  VTextFieldMessage.GetValue(page)
	If Connected Then 
		Mqtt.Publish("$banano",Message.GetBytes("UTF8"))
		VTextFieldMessage.SetValue(page,"")
	Else
		vuetify.ShowSnackBar("Sorry, isn't connected ")
	End If
End Sub

Sub mqtt_Connected (Success As Boolean)
	vuetify.ShowSnackBar("Conection: " & Success)
	Mqtt.Subscribe("$banano",2)
	Connected=Success
	Log("connected " & Success)
End Sub
Private Sub mqtt_Disconnected
	vuetify.ShowSnackBar("Disconnected")
	Log("Disconnected")
End Sub

Private Sub mqtt_MessageArrived (Topic As String, Payload() As Byte)
	Dim message As String = BytesToString(Payload,0,Payload.Length,"UTF8")
	Dim name As String = message.SubString2(0,message.IndexOf("|"))
	Dim text As String = message.SubString(message.IndexOf("|")+1)
	'vuetify.ShowSnackBar("Message: "  & message)
	VList1.AddItem("","","mdi-comment-account-outline","indigo", name,"")
	VList1.AddItemHeader(text)
	
	Log("mqtt_MessageArrived")
End Sub

'Use beforeDestroy if you need to clean-up events or reactive subscriptions:	
'Sub beforedestroy		'ignoreDeadCode
'	Log("beforedestroy")
'End Sub

'The updated hook runs after data changes on your component and the DOM re-renders.
'Sub updated			'ignoreDeadCode
'	Log("updated")
'End Sub

'The beforeUpdate hook runs after data changes on your component and the update cycle begins, right before the DOM is patched and re-rendered.
'Sub beforeupdate		'ignoreDeadCode
'	Log("beforeupdate")
'End Sub

'The beforeMount hook runs right before the initial render happens and after the template or render functions have been compiled:
'Sub beforemount		'ignoreDeadCode
'	Log("beforemount")
'End Sub

'The beforeCreate hook runs at the very initialization of your component. data has not been made reactive, and events have not been set up yet
'Sub beforecreate		'ignoreDeadCode
'	Log("beforecreate")
'End Sub

'You are able to access reactive data and events that are active with the created hook.
'Templates and Virtual DOM have not yet been mounted or rendered:
'Sub created		'IgnoreDeadCode
'	Log("created")
'End Sub

'In the mounted hook, you will have full access to the reactive component, templates, and rendered DOM
'Sub mounted		'ignoreDeadCode
'	Log("mounted")
'End Sub

'Use destroyed if you need do any last-minute cleanup or inform a remote server that the component was destroyed:
'Sub destroyed		'ignoreDeadCode
'	Log("destroyed")
'End Sub